'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp;

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('./utils');

var _withFormStore = require('./withFormStore');

var _withFormStore2 = _interopRequireDefault(_withFormStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DemonButton = (_dec = (0, _withFormStore2.default)(), _dec(_class = (_temp = _class2 = function (_Component) {
	_inherits(DemonButton, _Component);

	function DemonButton(props) {
		_classCallCheck(this, DemonButton);

		var _this = _possibleConstructorReturn(this, (DemonButton.__proto__ || Object.getPrototypeOf(DemonButton)).call(this, props));

		_this.handleClick = function () {
			var _this$props = _this.props,
			    forwardedProps = _this$props.forwardedProps,
			    propOnClick = _this$props.propOnClick;

			var onClick = forwardedProps[propOnClick];
			if ((0, _utils.isFunction)(onClick)) onClick.apply(undefined, arguments);
			_this.emit();
		};

		_this.handleKeyPress = function () {
			var _this$props2 = _this.props,
			    forwardedProps = _this$props2.forwardedProps,
			    propOnKeyPress = _this$props2.propOnKeyPress,
			    getKeyFromKeyPressEvent = _this$props2.getKeyFromKeyPressEvent;

			var onKeyPress = forwardedProps[propOnKeyPress];
			if ((0, _utils.isFunction)(onKeyPress)) onKeyPress.apply(undefined, arguments);
			try {
				var key = getKeyFromKeyPressEvent.apply(undefined, arguments);

				/* istanbul ignore else */
				if (key === 'Enter') _this.emit();
			} catch (err) /* istanbul ignore next */{
				(0, _utils.warn)('Failed to get value from "' + propOnKeyPress + '",', 'changing "props.getKeyFromKeyPressEvent" may resolve this problem.');
				console.error(err);
			}
		};

		_this.inputStore = props.formStore;
		return _this;
	}

	_createClass(DemonButton, [{
		key: 'emit',
		value: function emit() {
			var _props = this.props,
			    formStore = _props.formStore,
			    type = _props.type;

			formStore[type]();
		}
	}, {
		key: 'render',
		value: function render() {
			var _extends2;

			var _props2 = this.props,
			    forwardedProps = _props2.forwardedProps,
			    propOnClick = _props2.propOnClick,
			    propOnKeyPress = _props2.propOnKeyPress,
			    children = _props2.children;

			var props = _extends({}, forwardedProps, (_extends2 = {}, _defineProperty(_extends2, propOnClick, this.handleClick), _defineProperty(_extends2, propOnKeyPress, this.handleKeyPress), _extends2));
			return _react.Children.only(children(props));
		}
	}]);

	return DemonButton;
}(_react.Component), _class2.propTypes = {
	children: _propTypes2.default.func.isRequired,
	type: _propTypes2.default.oneOf(['submit', 'reset', 'clear']),
	formStore: _propTypes2.default.object.isRequired,
	forwardedProps: _propTypes2.default.object,
	getKeyFromKeyPressEvent: _propTypes2.default.func,
	propOnClick: _propTypes2.default.string,
	propOnKeyPress: _propTypes2.default.string
}, _class2.defaultProps = {
	forwardedProps: {},
	type: 'submit',
	getKeyFromKeyPressEvent: function getKeyFromKeyPressEvent(ev) {
		return ev.key;
	},
	propOnClick: 'onClick',
	propOnKeyPress: 'onKeyPress'
}, _temp)) || _class);
exports.default = DemonButton;